HonorGoldEnabled = true --this is a saved variable per char
HonorGold_AutoDeposit_enabled = false --this is a saved variable per char

local update_time = 0.1

local HonorGold = CreateFrame("Frame")
HonorGold:RegisterEvent("PLAYER_LOGIN")
HonorGold:RegisterEvent("ADDON_LOADED")
HonorGold:RegisterEvent("MERCHANT_SHOW")
HonorGold:RegisterEvent("MERCHANT_CLOSED")
HonorGold:RegisterEvent("BANKFRAME_OPENED")
HonorGold:RegisterEvent("BANKFRAME_CLOSED")

local floor = floor
local select = select
local BuyMerchantItem = BuyMerchantItem
local ContainerRefundItemPurchase = ContainerRefundItemPurchase
local GetContainerItemPurchaseInfo = GetContainerItemPurchaseInfo
local GetContainerNumSlots = GetContainerNumSlots
local GetMerchantItemLink = GetMerchantItemLink
local GetMerchantNumItems = GetMerchantNumItems
local UseContainerItem = UseContainerItem
local StaticPopup1Button1 = StaticPopup1Button1

local _
local dagger_id = 35058
local dagger_vendor_price
local money
local need_to_close
local vendor_item_index
local merchand_open
local bank_open
local dagger_merchant = {[12784] = true,[12794] = true,[40212] = true,[40216] = true}
local is_dagger_merchant
local deposit_table = {}
local withdraw_table = {}

local loop_bags
local Sell_Script
local Buy_Script
local Regret_Script
local Bank_Script
local Scan_Script
local display_gold_earned
local HonorGoldCommand 
local OnEvent

tooltip_scan = CreateFrame("GameTooltip","HonorGoldTooltipScan",UIParent,"GameTooltipTemplate")
tooltip_scan:SetOwner(UIParent,"ANCHOR_NONE")
local fresh_login = true

OnEvent = function(self,event,...)
	if event=="PLAYER_LOGIN" then
		_,_,_,_,_,_,_,_,_,_,dagger_vendor_price = GetItemInfo(dagger_id)
		if not dagger_vendor_price then
			HonorGold:RegisterEvent("GET_ITEM_INFO_RECEIVED")
		end
	elseif event=="GET_ITEM_INFO_RECEIVED" then
		item_id = ...
		if item_id==dagger_id then
			_,_,_,_,_,_,_,_,_,_,dagger_vendor_price = GetItemInfo(dagger_id)
			HonorGold:UnregisterEvent("GET_ITEM_INFO_RECEIVED")
		end
	elseif event=="ADDON_LOADED" and ...=="HonorGold" then
		if HonorGoldEnabled then
			HonorGold:SetScript("OnEvent",OnEvent)
		else
			HonorGold:SetScript("OnEvent",nil)
		end
	elseif event=="MERCHANT_SHOW" then
		merchand_open = true
		local merchant_guid = UnitGUID("target")
		is_dagger_merchant = dagger_merchant[tonumber((select(6,strsplit('-',merchant_guid))))]
		local items_to_sell
		items_to_sell,money = loop_bags(0,4,"count")
		if items_to_sell then
			self:SetScript("OnUpdate",Sell_Script)
		elseif UnitLevel("player")>=70 and is_dagger_merchant then
			vendor_item_index = nil
			if floor(select(2,GetCurrencyInfo(392))/105)>0 then
				self:SetScript("OnUpdate",Buy_Script)
			end
		end
	elseif event=="MERCHANT_CLOSED" then
		merchand_open = false
		self:SetScript("OnUpdate",nil)
	elseif event=="BANKFRAME_OPENED" then
		bank_open = true
		if fresh_login then
			self:SetScript("OnUpdate",Scan_Script)
		else
			self:SetScript("OnUpdate",Bank_Script)
		end
	elseif event=="BANKFRAME_CLOSED" then
		bank_open = false
		self:SetScript("OnUpdate",nil)
	end
end
HonorGold:SetScript("OnEvent",OnEvent)

Sell_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>update_time then
		self.timer = 0
		if not loop_bags(0,4,"sell") then
			self:SetScript("OnUpdate",nil)
			display_gold_earned(money)
			if UnitLevel("player")>=70 and is_dagger_merchant then
				vendor_item_index = nil
				if floor(select(2,GetCurrencyInfo(392))/105)>0 then
					self:SetScript("OnUpdate",Buy_Script)
				end
			end
		end
	end
end

Buy_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>update_time then
		self.timer = 0
		MerchantFrame_SetFilter(MerchantFrame,1)
		local i = 1
		local link
		while not vendor_item_index and i<=GetMerchantNumItems() do
			link = GetMerchantItemLink(i)
			if link and tonumber(link:match("item:(%d+)"))==dagger_id then
				vendor_item_index = i
			else
				i = i+1
			end
		end
		if vendor_item_index then
			local n = floor(select(2,GetCurrencyInfo(392))/105)
			if n>0 then
				BuyMerchantItem(vendor_item_index)
				StaticPopup1Button1:Click()
			else
				CloseMerchant()
				self:SetScript("OnUpdate",nil)
			end
		end
		UIErrorsFrame:Clear()
	end
end

Regret_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>30*update_time then
		self.timer = 0
		if not loop_bags(0,4,"regret") then
			HonorGold:SetScript("OnUpdate",nil)
		end
	end
end

local function deposit_function()
	if bank_open then
		loop_bags(0,4,"deposit")
		for i=12,1,-1 do
			if deposit_table[i] then
				for k,v in pairs(deposit_table[i]) do
					local bag,slot = v[1],v[2]
					UseContainerItem(bag,slot)
				end
			end
		end
		wipe(deposit_table)
	end
end

Bank_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>(fresh_login and 2.5 or update_time) then
		self.timer = 0
		if HonorGold_AutoDeposit_enabled then
			deposit_function() --introduced to autodeposit
		end
		loop_bags(5,11,"withdraw_ready")
		loop_bags(-1,-1,"withdraw_ready")
		HonorGold:SetScript("OnUpdate",nil)
		fresh_login = false
	end
end

Scan_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>update_time then
		self.timer = 0
		if not (loop_bags(0,4,"scan_tooltip") or loop_bags(5,11,"scan_tooltip") or loop_bags(-1,-1,"scan_tooltip")) then
			HonorGold:SetScript("OnUpdate",Bank_Script)
		end
	end
end

display_gold_earned = function(money)
	local g,s,c,text
	g = floor(money/10000)
	s = floor((money-g*10000)/100)
	c = mod(money,100)
	text = ""
	if g>0 then
		text = g.." gold"
	end
	if s>0 then
		text = text.." "..s.." silver"
	end
	if c>0 then
		text = text.." "..c.." copper"
	end
	text = text.."."
	DEFAULT_CHAT_FRAME:AddMessage("HonorGold: You received "..text,0,1,0)
end

loop_bags = function(bag_min,bag_max,what_for)
	local return_value1
	local return_value2
	local link
	for bag=bag_min,bag_max do
		local n = GetContainerNumSlots(bag)
		if n then
			for slot=1,n do
				link = GetContainerItemLink(bag,slot)
				if link and tonumber(link:match("item:(%d+)"))==dagger_id then
					if what_for=="count" then
						if GetContainerItemPurchaseInfo(bag,slot)==nil then
							return_value1 = true
							return_value2 = return_value2 and return_value2+dagger_vendor_price or dagger_vendor_price
						end
					elseif what_for=="sell" then
						if GetContainerItemPurchaseInfo(bag,slot)==nil then
							UseContainerItem(bag,slot)
							return_value1 = true
						end
					elseif what_for=="regret" then
						if GetContainerItemPurchaseInfo(bag,slot)~=nil then
							ContainerRefundItemPurchase(bag,slot)
							StaticPopup1Button1:Click()
							return_value1 = true
						end
					elseif what_for=="deposit" then
						local _,_,regret_time = GetContainerItemPurchaseInfo(bag,slot)
						if regret_time then
							local index = floor((regret_time-1)/600+1)
							if deposit_table[index] then
								table.insert(deposit_table[index],{bag,slot})
							else
								deposit_table[index] = {{bag,slot}}
							end
						end
					elseif what_for=="withdraw_ready" then
						if bag==-1 then
							tooltip_scan:SetInventoryItem("player",BankButtonIDToInvSlotID(slot,nil))
						else
							tooltip_scan:SetBagItem(bag,slot)
						end
						if GetContainerItemPurchaseInfo(bag,slot)==nil then
							UseContainerItem(bag,slot)
						end
					elseif what_for=="withdraw_all" then
						local _,_,regret_time = GetContainerItemPurchaseInfo(bag,slot)
						if regret_time then
							local index = floor((regret_time-1)/600+1)
							if withdraw_table[index] then
								table.insert(withdraw_table[index],{bag,slot})
							else
								withdraw_table[index] = {{bag,slot}}
							end
						end
					elseif what_for=="scan_tooltip" then
						if bag==-1 then
							tooltip_scan:SetInventoryItem("player",BankButtonIDToInvSlotID(slot,nil))
						else
							tooltip_scan:SetBagItem(bag,slot)
						end
						if HonorGoldTooltipScanTextLeft1:GetText()==nil then
							return_value1 = true
						end
					end
				end
			end
		end
	end
	UIErrorsFrame:Clear()
	return return_value1,return_value2
end

HonorGoldCommand = function(msg)
	if msg=="" then
		if not HonorGoldEnabled then
			HonorGoldEnabled = true
			HonorGold:SetScript("OnEvent",OnEvent)
			DEFAULT_CHAT_FRAME:AddMessage("HonorGold enabled.",0,1,0)
		else
			HonorGoldEnabled = false
			HonorGold:SetScript("OnEvent",nil)
			HonorGold:SetScript("OnUpdate",nil)
			DEFAULT_CHAT_FRAME:AddMessage("HonorGold disabled.",1,0,0)
		end
	elseif string.upper(msg)=="DEPOSIT" then
		deposit_function()
	elseif string.upper(msg)=="WITHDRAW" then
		if bank_open then
			loop_bags(-1,-1,"withdraw_all")
			loop_bags(5,11,"withdraw_all")
			for i=1,12 do
				if withdraw_table[i] then
					for k,v in pairs(withdraw_table[i]) do
						local bag,slot = v[1],v[2]
						UseContainerItem(bag,slot)
					end
				end
			end
			wipe(withdraw_table)			
		end
	elseif string.upper(msg)=="AUTODEPOSIT" then
		if not HonorGold_AutoDeposit_enabled then
			HonorGold_AutoDeposit_enabled = true
			DEFAULT_CHAT_FRAME:AddMessage("HonorGold: autodeposit enabled.",0,1,0)
		else
			HonorGold_AutoDeposit_enabled = false
			DEFAULT_CHAT_FRAME:AddMessage("HonorGold: autodeposit disabled.",1,0,0)
		end		
	elseif string.upper(msg)=="REGRET" then
		if merchand_open then
			HonorGold:SetScript("OnUpdate",Regret_Script)
		end
	elseif string.upper(msg)=="HELP" then
		print("HONORGOLD: \"/honorgold deposit\" : deposit all daggers with regret time in the bank.")
		print("HONORGOLD: \"/honorgold withdraw\" : withdraw daggers with regret time from the bank (daggers without regret time are always withdrawn).")
		print("HONORGOLD: \"/honorgold autodeposit\" : enable/disable daggers with regret time being automatically deposited in the bank.")
		print("HONORGOLD: \"/honorgold regret\" : resell daggers with regret time to restore honor points.")
	else
		DEFAULT_CHAT_FRAME:AddMessage("HonorGold: Command not found.",1,0,0)
	end
end

SlashCmdList["HonorGold"] = HonorGoldCommand
SLASH_HonorGold1 = "/honorgold"